﻿namespace ScriptCaching
{
    // inherit COM interface which is exposed to WinWrap Basic
    internal class CScript : Script
    {
        private ScriptManager script_manager_;
        private ScriptNode script_node_;

        internal CScript(ScriptManager script_manager, ScriptNode script_node)
        {
            script_manager_ = script_manager;
            script_node_ = script_node;
            script_node_.Active(true);
        }

        ~CScript()
        {
            script_node_.Active(false);
        }

        public object Evaluate(object default_value = null)
        {
            // evaluate the script, a WinWrap Basic run-time error will throw an exception
            return script_manager_.EvaluateScript(script_node_, default_value);
        }
    }

    // inherit COM interface which is exposed to WinWrap Basic
    internal class CExtensions : Extensions
    {
        private ScriptManager script_manager_;

        internal CExtensions(ScriptManager script_manager)
        {
            script_manager_ = script_manager;
        }

        public Script LoadScript(string script_name)
        {
            // load the script, a WinWrap Basic syntax error will throw an exception
            ScriptNode script_node = script_manager_.LoadScript(script_name);
            // return a Script COM object
            return new CScript(script_manager_, script_node);
        }
    }
}
